--============================================================================
--===================       Aardvark ~ R 1.15.6.2     =========================
--===================            Walkerbo            =========================
--===================         Wednesday, 15 July 2015      =========================
--============================================================================

--============================================================================
--===========================   METRICS   ====================================
--============================================================================

local AVKTitle = "Aardvark"
local AVKVersion = " ~ R 1.15.6.2"

local AVKImg = {
	avkban = "Interface\\AddOns\\Aardvark\\Files\\AVK_ban", --  Aardvark Banner
	avki = "Interface\\AddOns\\Aardvark\\Files\\AVK_icon", -- Aardvark Icon
	avki_alt = "Interface\\AddOns\\Aardvark\\Files\\AVK_icon_alt", -- Aardvark Icon Alt
	avksi = "Interface\\AddOns\\Aardvark\\Files\\AVKS_icon", -- Aardvark Sell Icon
	avksi_alt = "Interface\\AddOns\\Aardvark\\Files\\AVKS_icon_alt", -- Aardvark Sell Icon Alt
	avkdi = "Interface\\AddOns\\Aardvark\\Files\\AVKD_icon", -- Aardvark Destroy Icon
	avkdi_alt = "Interface\\AddOns\\Aardvark\\Files\\AVKD_icon_alt", -- Aardvark Destroy Icon Alt
	avkri = "Interface\\AddOns\\Aardvark\\Files\\AVKR_icon", -- Aardvark Repair Icon
	avkri_alt = "Interface\\AddOns\\Aardvark\\Files\\AVKR_icon_alt", -- Aardvark Repair Icon Alt
	avkci = "Interface\\AddOns\\Aardvark\\Files\\AVK_cx_icon", -- Aardvark Close Icon
}

local AVKCBFontB = CreateFont("TheAVKCBFB")-- Aardvark CheckBox Big Font
AVKCBFontB:SetFont("Interface\\AddOns\\Aardvark\\Files\\neuropol.ttf", 19,"OUTLINE")
local AVKCBFontN = CreateFont("TheAVKCBFN")-- Aardvark CheckBox Normal Font
AVKCBFontN:SetFont("Interface\\AddOns\\Aardvark\\Files\\vixar.TTF", 13,"OUTLINE")
local AVKCFont = CreateFont("TheAVKCF")-- Aardvark Content Font
AVKCFont:SetFont("Interface\\AddOns\\Aardvark\\Files\\vixar.TTF", 13,"OUTLINE")
local AVKAFont = CreateFont("TheAVKAF")-- Aardvark Content Font
AVKAFont:SetFont("Interface\\AddOns\\Aardvark\\Files\\vixar.TTF", 12,"OUTLINE")

local AVKFont = {
    fb="|cff00ffff",  -- Blue
    fbp="|cff00ffff ["..AVKTitle.."]: ",  -- Blue + Prefix
    fbpc="|cff00ffff ["..AVKTitle.."]: |r",  -- Blue + Prefix + Postfix
    fg="|cff00ff00",  -- Sell Green
    fr="|cffff0000",  -- Destroy Red
    fp="|cffff00ff", -- Repair Pink
}

local AVKText = {
    alm=(" *** "..AVKTitle..AVKVersion.." Loaded *** "),  -- Load Message
    aot=("Slash Commands:\n "..AVKFont.fb.."/avk |r~ Show/Hide Aardvark frame\n "..AVKFont.fb.."/avkdestroy |r~ Destroy function\n "..AVKFont.fb.."/avkpos |r~ Reset Aardvark frame and button positions\n "..AVKFont.fb.."/avkclean |r~ Clear all lists\n "..AVKFont.fb.."/avkreset |r~ Reset Aardvark to factory settings"), -- Options Text
    sot=("Sell Text"),  -- Sell Text
    dot=("The Aardvark Destroy function will"..AVKFont.fr.." destroy|r the items you have added to your destroy list.\n"..AVKFont.fr.."\nDestroyed items CANNOT be recovered|r, there are no take backs, no do-overs, no whoops didn't mean to do that, etc.\n\nYou have been warned!"),  -- Destroy Text
    rot=("Repair Text"),  -- Repair Text
    att=("Drag&Drop / Click&Drop: Add Item to List\nLeft Click: Show/Hide Aardvark Frame\nMiddle Click + Drag: Move Aardvark Button\nRight Click: Destroy Listed Items"), -- Aardvark Button Tooltip Text
    aat=("There once was a little aardvark that grew up in Azeroth.\n\nHe loved farming, but after few years he developed RSI in his little paws as he was always clicking to sell items that he didn\'t want, dragging and dropping items that he couldn\'t sell and in a lot of cases deleting items just to clean out his bags ready to farm again.\n\nOne day after an extremely long day of farming he thought "..AVKFont.fb.."\"what if I could just open my bags and have all the stuff I don\'t want disappear?\"|r \n\nWith this thought he started to teach his little arthritic paws how to code. His code is very messy and not efficient but it does what he wants it to do.\n\nHopefully you can find it useful too."), -- Aardvark Text
    avt=(AVKFont.fb.."Version"..AVKVersion), -- Version Print
}

local AVKSize = {
    mfw=302,-- Main Frame Width
    mfh=440,-- Main Frame Height
    mft=35, -- Main Frame Top Gap
    mfs=20, -- Main Frame Side Gap
    mfbs=10,-- Main Frame Bottom Gap
    mfb=34,-- Main Frame Button Size
    mfbyg=-80,-- Main Frame Button Y Gap
    mfbxg=22, -- Main Frame Button X Gap
    mpw=282,-- Main Panel Width
    mph=307,-- Main Panel Height
    sph=211,-- Scroll Parent Height
    sbn=12, -- Scroll Button Number
    sbh=16,-- Scroll Button Height
    cbfxg=10, -- Checkbox First X Gap
    cbfyg=-10, -- Checkbox First Y Gap
    cbbs=26,-- Checkbox Big Size
    cbns=22,-- Checkbox Normal Size
    cbcyg=8, -- Checkbox Child Y Gap
    cbbxg=-26,-- Checkbox Big X Gap
    cbnxg=-22,-- Checkbox Normal X Gap
}

local AVKVendorBlacklist = {
    27914, -- Ethereal Soul-Trader
	79828, -- Murg
	87302, -- Murg -- Yes this is a second Murg, no I have no idea why
	--	77368, -- Madison Clark  --  This NPC can now buy items
	63596, -- Audrey Burnhep
}

local AVK_mainBtn  -- Aardvark Main Button

--============================================================================
--======================    AARDVARK MAIN FRAME   ============================
--============================================================================

--=====================     Aardvark Options Frame      ======================
local AVK_mFrm=CreateFrame("Frame","Aardvark_Main_Frame",UIParent,"TooltipBorderedFrameTemplate")
AVK_mFrm:SetBackdrop({bgFile=nil, insets={nil}, tileSize=nil, tile=false, edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", edgeSize=20})
AVK_mFrm:SetBackdropBorderColor(0,1,1,1)
AVK_mFrm:SetSize(AVKSize.mfw,AVKSize.mfh)
AVK_mFrm:ClearAllPoints()
AVK_mFrm:SetPoint("LEFT",300,50)
AVK_mFrm:EnableMouse(true)
AVK_mFrm:SetMovable(true)
AVK_mFrm:RegisterForDrag("LeftButton")
AVK_mFrm:SetScript("OnDragStart",AVK_mFrm.StartMoving)
AVK_mFrm:SetScript("OnDragStop",AVK_mFrm.StopMovingOrSizing)
AVK_mFrm:SetToplevel(true)
AVK_mFrm:Hide()

-- Aardvark Options Frame Banner
AVK_mFrm_ban = CreateFrame("Frame", "AVK_Options_Banner",AVK_mFrm)
AVK_mFrm_ban:SetSize(512,86)
AVK_mFrm_ban:SetPoint("TOP",0, -22)
AVK_mFrm_ban.Texture = AVK_mFrm_ban:CreateTexture(nil, "BACKGROUND")
AVK_mFrm_ban.Texture:SetSize(270,270)
AVK_mFrm_ban.Texture:SetPoint("TOP", 0, 0)
AVK_mFrm_ban.Texture:SetTexture(AVKImg.avkban)
AVK_mFrm_ban.Texture:Show()

-- Aardvark Options Frame Close Button
local AVK_mFrm_cBtn=CreateFrame("Button","AVK_Options_Frame_Close_Button",AVK_mFrm)
AVK_mFrm_cBtn:SetPoint("TOPRIGHT", -6, -6)
AVK_mFrm_cBtn:SetSize(16,16)
AVK_mFrm_cBtn:SetNormalTexture(AVKImg.avkci)
AVK_mFrm_cBtn:SetHighlightTexture(AVKImg.avkci,"DISABLE")
AVK_mFrm_cBtn:SetScript("OnClick",function(self)
    AVK_mFrm:Hide()
end)

-- Aardvark Options Frame Script
AVK_mFrm:SetScript("OnEvent",function(self,event,...)
	
	print(AVKFont.fbp..AVKText.alm)
	
	if not Aardvark_DB then  -- If Temp_AVK_DB is nil then build table
		Aardvark_DB={
			AVK_amb=true,    -- Aardvark Main Button
			AVK_avb=true,  -- Aardvark Vendor Button
			AVK_asm=true, -- Aardvark Selection Messages
			AVK_alit=true, -- Aardvark Listed Item ToolTips
			AVK_almm=true, -- Aardvark List Management Messages
			
			AVKR_re=true,        -- Aardvark Repair Enabled
			AVKR_rgr=false,    -- Aardvark Guild Repair
			AVKR_rnrm=true,    -- Aardvark Repair Not Required Message
			AVKR_necm=true,    -- Aardvark Repair Not Enough Cash Message
			AVKR_vcrm=true,    -- Aardvark Repair Vendor Cannot Repair Message
			AVKR_rm=true,    -- Aardvark Repair Meter
			
			AVKS_se=true,        -- Aardvark Sell Enabled
			AVKS_as=false,    -- Aardvark Auto Sell Enabled
			AVKS_svb=true, -- Aardvark Sell Vendor Frame Button
			AVKS_dsm=true,    -- Aardvark Detailed Sell Messages
			AVKS_ntsm=true,    -- Aardvark Nothing To Sell Message
			
			AVKD_de=true,    -- Aardvark Destroy enabled
			AVKD_ad=false,    -- Aardvark Auto Destroy
			AVKD_dvb=true, -- Aardvark Destroy Vendor Frame Button
			AVKD_ddm=true,    -- Aardvark Detailed Destroy Messages
			AVKD_ntdm=true,    -- Aardvark Nothing To Destroy Message
		}
		AVK_mFrm:Show()    -- First Run show Aardvark Frame
	end
	
	if not Aardvark_Sell_DB then 
		Aardvark_Sell_DB={}   -- Nil Sell DB
		Aardvark_Destroy_DB={}  -- Nil Destroy DB
	end
	
	--=============================================================================
	--=====================     AARDVARK PANEL BUTTONS       ======================
	--=============================================================================
	
	--=====================   Aardvark Options Panel Button   =====================
	local AVK_opb=CreateFrame("Button","AVK_Options_Panel_Button",AVK_mFrm)
	AVK_opb:SetPoint("TOPLEFT", AVKSize.mfbxg, AVKSize.mfbyg)
	AVK_opb:SetSize(AVKSize.mfb,AVKSize.mfb)
	AVK_opb:SetNormalTexture(AVKImg.avki)
	AVK_opb:SetHighlightTexture(AVKImg.avki_alt,"BLEND")
	AVK_opb:SetScript("OnClick",function(self)
		optionsButton()
	end)
	
	--=====================   Aardvark Sell Panel Button   ======================
	local AVK_spb=CreateFrame("Button","AVK_Sell_Panel_Button",AVK_mFrm)
	AVK_spb:SetPoint("RIGHT", AVK_opb, AVKSize.mfb+AVKSize.mfbxg, 0)
	AVK_spb:SetSize(AVKSize.mfb,AVKSize.mfb)
	AVK_spb:SetNormalTexture(AVKImg.avksi)
	AVK_spb:SetHighlightTexture(AVKImg.avksi_alt,"BLEND")
	AVK_spb:SetScript("OnClick",function(self)
		sellButton()
	end)
	
	--=====================   Aardvark Destroy Panel Button   ======================
	local AVK_dpb=CreateFrame("Button","AVK_Destroy_Panel_Button",AVK_mFrm)
	AVK_dpb:SetPoint("RIGHT", AVK_spb, AVKSize.mfb+AVKSize.mfbxg, 0)
	AVK_dpb:SetSize(AVKSize.mfb,AVKSize.mfb)
	AVK_dpb:SetNormalTexture(AVKImg.avkdi)
	AVK_dpb:SetHighlightTexture(AVKImg.avkdi_alt,"BLEND")
	AVK_dpb:SetScript("OnClick",function(self)
		destroyButton()
	end)
	
	--=====================   Aardvark Repair Panel Button   ======================
	local AVK_rpb=CreateFrame("Button","AVK_Destroy_Panel_Button",AVK_mFrm)
	AVK_rpb:SetPoint("RIGHT", AVK_dpb, AVKSize.mfb+AVKSize.mfbxg, 0)
	AVK_rpb:SetSize(AVKSize.mfb,AVKSize.mfb)
	AVK_rpb:SetNormalTexture(AVKImg.avkri)
	AVK_rpb:SetHighlightTexture(AVKImg.avkri_alt,"BLEND")
	AVK_rpb:SetScript("OnClick",function(self)
		repairButton()
	end)
	
	--=====================   Aardvark About Panel Button   ======================
	local AVK_apb=CreateFrame("Button","AVK_About_Panel_Button",AVK_mFrm)
	AVK_apb:SetPoint("RIGHT", AVK_rpb, AVKSize.mfb+AVKSize.mfbxg, 0)
	AVK_apb:SetSize(AVKSize.mfb,AVKSize.mfb)
	AVK_apb:SetNormalTexture(AVKImg.avki)
	AVK_apb:SetHighlightTexture(AVKImg.avki_alt,"BLEND")
	AVK_apb:SetScript("OnClick",function(self)
		aardvarkButton()
	end)
	
	--============================================================================
	--=====================      AARDVARK OPTIONS PANEL     ======================
	--============================================================================
	
	--=====================   Aardvark Options Parent   ======================
	local AVK_op = CreateFrame("Frame","Aardvark_Options_Parent",AVK_mFrm)
	AVK_op:SetSize(AVKSize.mpw,AVKSize.mph)
	AVK_op:SetPoint("BOTTOM",0,AVKSize.mfbs)
	AVK_op:SetBackdrop( {nil, insets={}, tileSize=nil, tile=false, edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16 } )
	AVK_op:SetBackdropBorderColor(0,1,1,1)
	
	--============================================================================
	--=======================      AARDVARK OPTIONS       ========================
	--============================================================================
	
	--=====================   Aardvark Main Button    ======================
	local AVK_fBtn_cb=CreateFrame("CheckButton","Aardvark_Main_Button_Checkbox",AVK_op,"UICheckButtonTemplate")
	AVK_fBtn_cb:ClearAllPoints()
	AVK_fBtn_cb:SetPoint("TOPLEFT",AVK_op,AVKSize.cbfxg,AVKSize.cbfyg)
	AVK_fBtn_cb:SetSize(AVKSize.cbbs,AVKSize.cbbs)
	AVK_fBtn_cb.text:SetText(AVKFont.fb.."Aardvark Button")
	AVK_fBtn_cb.text:SetFontObject(AVKCBFontB)
	-- Aardvark mark checkbox display
	if Aardvark_DB.AVK_amb==true then
		AVK_fBtn_cb:SetChecked(true)
		AVK_mainBtn:Show()
        else
		AVK_fBtn_cb:SetChecked(false)
		AVK_mainBtn:Hide()
	end
	-- Aardvark checkbox function
	AVK_fBtn_cb:SetScript("OnClick", function()
		if Aardvark_DB.AVK_amb==true then
			Aardvark_DB.AVK_amb=false
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Aardvark Button Disabled")
			end
			AVK_mainBtn:Hide()
            else
			Aardvark_DB.AVK_amb=true
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Aardvark Button Enabled")
			end
			AVK_mainBtn:Show()
		end
	end)
	
	--=================   Aardvark Vendor Frame Button    ====================
	local AVK_mBtn_cb=CreateFrame("CheckButton","Aardvark_Merchant_Frame_Button_Checkbox",AVK_op,"UICheckButtonTemplate")
	AVK_mBtn_cb:ClearAllPoints()
	AVK_mBtn_cb:SetPoint("BOTTOMLEFT",AVK_fBtn_cb,0,AVKSize.cbbxg)
	AVK_mBtn_cb:SetSize(AVKSize.cbbs,AVKSize.cbbs)
	AVK_mBtn_cb.text:SetText(AVKFont.fb.."Aardvark Vendor Button")
	AVK_mBtn_cb.text:SetFontObject(AVKCBFontB)
	-- Aardvark mark checkbox display
	if Aardvark_DB.AVK_avb==true then
		AVK_mBtn_cb:SetChecked(true)
        else
		AVK_mBtn_cb:SetChecked(false)
	end
	-- Aardvark checkbox function
	AVK_mBtn_cb:SetScript("OnClick", function()
		if Aardvark_DB.AVK_avb==true then
			Aardvark_DB.AVK_avb=false
			updateMerchButtons()
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Aardvark Vendor Frame Button Disabled")
			end
            else
			Aardvark_DB.AVK_avb=true
			updateMerchButtons()
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Aardvark Vendor Frame Button Enabled")
			end
		end
	end)
	
	--=================   Aardvark System Messages   ===================
	local AVK_sm_cb=CreateFrame("CheckButton","Aardvark_System_Messages_Checkbox",AVK_op,"UICheckButtonTemplate")
	AVK_sm_cb:ClearAllPoints()
	AVK_sm_cb:SetPoint("BOTTOMLEFT",AVK_mBtn_cb,0,AVKSize.cbbxg)
	AVK_sm_cb:SetSize(AVKSize.cbbs,AVKSize.cbbs)
	AVK_sm_cb.text:SetText(AVKFont.fb.."Selection Messages")
	AVK_sm_cb.text:SetFontObject(AVKCBFontB)
	-- Aardvark mark checkbox display
	if Aardvark_DB.AVK_asm==true then
		AVK_sm_cb:SetChecked(true)
        else
		AVK_sm_cb:SetChecked(false)
	end
	-- Aardvark checkbox function
	AVK_sm_cb:SetScript("OnClick",function()
		if Aardvark_DB.AVK_asm==true then
			Aardvark_DB.AVK_asm=false
			print(AVKFont.fbp.."Selection Messages Disabled")
            else
			Aardvark_DB.AVK_asm=true
			print(AVKFont.fbp.."Selection Messages Enabled")
		end
	end)
	
	--=================   Aardvark Listed Item Tooltips    ====================
	local AVK_lit_cb=CreateFrame("CheckButton","Aardvark_Listed_Item_Tooltips_Checkbox",AVK_op,"UICheckButtonTemplate")
	AVK_lit_cb:ClearAllPoints()
	AVK_lit_cb:SetPoint("BOTTOMLEFT",AVK_sm_cb,0,AVKSize.cbbxg)
	AVK_lit_cb:SetSize(AVKSize.cbbs,AVKSize.cbbs)
	AVK_lit_cb.text:SetText(AVKFont.fb.."Listed Item Tooltips")
	AVK_lit_cb.text:SetFontObject(AVKCBFontB)
	-- Aardvark mark checkbox display
	if Aardvark_DB.AVK_alit==true then
		AVK_lit_cb:SetChecked(true)
        else
		AVK_lit_cb:SetChecked(false)
	end
	-- Aardvark checkbox function
	AVK_lit_cb:SetScript("OnClick", function()
		if Aardvark_DB.AVK_alit==true then
			Aardvark_DB.AVK_alit=false
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Listed Item Tooltips Disabled")
			end
            else
			Aardvark_DB.AVK_alit=true
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Listed Item Tooltips Enabled")
			end
		end
	end)
	
	--=================   Aardvark List Management Messages    ====================
	local AVK_lmm_cb=CreateFrame("CheckButton","Aardvark_List_Management_Messages_Checkbox",AVK_op,"UICheckButtonTemplate")
	AVK_lmm_cb:ClearAllPoints()
	AVK_lmm_cb:SetPoint("BOTTOMLEFT",AVK_lit_cb,0,AVKSize.cbbxg)
	AVK_lmm_cb:SetSize(AVKSize.cbbs,AVKSize.cbbs)
	AVK_lmm_cb.text:SetText(AVKFont.fb.."Add Item Messages")
	AVK_lmm_cb.text:SetFontObject(AVKCBFontB)
	-- Aardvark mark checkbox display
	if Aardvark_DB.AVK_almm==true then
		AVK_lmm_cb:SetChecked(true)
        else
		AVK_lmm_cb:SetChecked(false)
	end
	-- Aardvark checkbox function
	AVK_lmm_cb:SetScript("OnClick", function()
		if Aardvark_DB.AVK_almm==true then
			Aardvark_DB.AVK_almm=false
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Add Item Messages Disabled")
			end
            else
			Aardvark_DB.AVK_almm=true
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Add Item Messages Enabled")
			end
		end
	end)
	
	--=====================   Aardvark Options Text   ======================
	local AVK_oTxt = CreateFrame("Frame","Aardvark_Options_Text_Frame",AVK_op)
	AVK_oTxt:SetSize(AVKSize.mpw-AVKSize.mfs,AVKSize.sph/10*8)
	AVK_oTxt:SetPoint("BOTTOM",0,10)
	AVK_oTxtC=AVK_oTxt:CreateFontString("Aardvark_Options_Text")
	AVK_oTxtC:SetPoint("TOP",0,-26)
	AVK_oTxtC:SetJustifyH("left")
	AVK_oTxtC:SetAllPoints(AVK_oTxt)
	AVK_oTxtC:SetFontObject(AVKCFont)
	AVK_oTxtC:SetText(AVKText.aot)
	
	--==================  Aardvark Vendor Button    ==================
	local AVK_aMercBtn=CreateFrame("Button","Aardvark_Merchant_Button",MerchantFrame)
	AVK_aMercBtn:SetSize(24,24)
	AVK_aMercBtn:SetPoint("TOPLEFT",MerchantFrame,60,-30)
	AVK_aMercBtn:SetNormalTexture(AVKImg.avki)
	AVK_aMercBtn:SetHighlightTexture(AVKImg.avki_alt,"BLEND")
	-- drag & drop function
	AVK_aMercBtn:SetScript("OnReceiveDrag",function()
		AVK_addItemToList()
	end)
	-- click function
	AVK_aMercBtn:RegisterForClicks("LeftButtonUp")
	AVK_aMercBtn:SetScript("OnClick", function()
		if GetCursorInfo() then
			AVK_addItemToList()
            else
			if AVK_mFrm:IsShown()==false then
				AVKS_sellUpdate()
				AVKD_destroyUpdate()
				AVK_mFrm:Show()
                else
				AVK_mFrm:Hide()
			end
		end
	end)
	AVK_aMercBtn:RegisterEvent("MERCHANT_SHOW")
	
	--============================================================================
	--==================      AARDVARK SELL OPTIONS PANEL     ====================
	--============================================================================
	
	--=================   Aardvark Sell Options Parent Panel    ======================
	local AVKS_sop = CreateFrame("Frame","Aardvark_Sell_Options_Parent",AVK_mFrm)
	AVKS_sop:SetSize(AVKSize.mpw,AVKSize.mph)
	AVKS_sop:SetPoint("BOTTOM",0,AVKSize.mfbs)
	AVKS_sop:SetBackdrop( {nil, insets={}, tileSize=nil, tile=false, edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16 } )
	AVKS_sop:SetBackdropBorderColor(0,1,0,1)
	AVKS_sop:Hide()
	
	--============================================================================
	--=====================      AARDVARK SELL OPTIONS      ======================
	--============================================================================
	
	--=====================   Aardvark Sell Enable    ======================
	local AVKS_e_cb=CreateFrame("CheckButton","Aardvark_Sell_Checkbox",AVKS_sop,"UICheckButtonTemplate")
	AVKS_e_cb:ClearAllPoints()
	AVKS_e_cb:SetPoint("TOPLEFT",AVKSize.cbfxg,AVKSize.cbfyg)
	AVKS_e_cb:SetSize(AVKSize.cbbs,AVKSize.cbbs)
	AVKS_e_cb.text:SetText(AVKFont.fg.."Enable Aardvark Sell")
	AVKS_e_cb.text:SetFontObject(AVKCBFontB)
	-- Aardvark mark checkbox display
	if Aardvark_DB.AVKS_se==true then
		AVKS_e_cb:SetChecked(true)
        else
		AVKS_e_cb:SetChecked(false)
	end
	
	--=====================     Aardvark Auto Sell    ======================
	local AVKS_ea_cb=CreateFrame("CheckButton","Aardvark_Sell_Auto_Checkbox",AVKS_sop,"UICheckButtonTemplate")
	AVKS_ea_cb:ClearAllPoints()
	AVKS_ea_cb:SetParent(AVKS_e_cb)
	AVKS_ea_cb:SetPoint("BOTTOMRIGHT",AVKS_e_cb,AVKSize.cbcyg,AVKSize.cbnxg)
	AVKS_ea_cb:SetSize(AVKSize.cbns,AVKSize.cbns)
	AVKS_ea_cb.text:SetText(" Enable Auto Sell")
	AVKS_ea_cb.text:SetFontObject(AVKCBFontN)
	-- Aardvark mark checkbox display
	-- If Aardvark Sell is disabled hide checkbox
	if Aardvark_DB.AVKS_se==true and Aardvark_DB.AVKS_as==true then
		AVKS_ea_cb:SetChecked(true)
		AVKS_ea_cb:Show()
        elseif Aardvark_DB.AVKS_se==true and Aardvark_DB.AVKS_as==false then
		AVKS_ea_cb:SetChecked(false)
		AVKS_ea_cb:Show()
        elseif Aardvark_DB.AVKS_se==false and Aardvark_DB.AVKS_as==false then
		AVKS_ea_cb:SetChecked(false)
		AVKS_ea_cb:Hide()
        else
		AVKS_ea_cb:SetChecked(true)
		AVKS_ea_cb:Hide()
	end
	-- Aardvark checkbox function
	AVKS_ea_cb:SetScript("OnClick", function()
		if Aardvark_DB.AVKS_as==true then
			Aardvark_DB.AVKS_as=false
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Auto Sell Disabled")
			end
            else
			Aardvark_DB.AVKS_as=true
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Auto Sell Enabled")
			end
		end
	end)
	
	--=====================     Aardvark Sell Vendor Button    ======================
	local AVKS_svb_cb=CreateFrame("CheckButton","Aardvark_Sell_Vendor_Button_Checkbox",AVKS_sop,"UICheckButtonTemplate")
	AVKS_svb_cb:ClearAllPoints()
	AVKS_svb_cb:SetParent(AVKS_e_cb)
	AVKS_svb_cb:SetPoint("BOTTOMRIGHT",AVKS_ea_cb,0,AVKSize.cbnxg)
	AVKS_svb_cb:SetSize(AVKSize.cbns,AVKSize.cbns)
	AVKS_svb_cb.text:SetText(" Sell Vendor Button")
	AVKS_svb_cb.text:SetFontObject(AVKCBFontN)
	-- Aardvark mark checkbox display
	-- If Aardvark Sell is disabled hide checkbox
	if Aardvark_DB.AVKS_se==true and Aardvark_DB.AVKS_svb==true then
		AVKS_svb_cb:SetChecked(true)
		AVKS_svb_cb:Show()
        elseif Aardvark_DB.AVKS_se==true and Aardvark_DB.AVKS_svb==false then
		AVKS_svb_cb:SetChecked(false)
		AVKS_svb_cb:Show()
        elseif Aardvark_DB.AVKS_se==false and Aardvark_DB.AVKS_svb==false then
		AVKS_svb_cb:SetChecked(false)
		AVKS_svb_cb:Hide()
        else
		AVKS_svb_cb:SetChecked(true)
		AVKS_svb_cb:Hide()
	end
	-- Aardvark checkbox function
	AVKS_svb_cb:SetScript("OnClick", function()
		if Aardvark_DB.AVKS_svb==true then
			Aardvark_DB.AVKS_svb=false
			updateMerchButtons()
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Sell Vendor Button Disabled")
			end
            else
			Aardvark_DB.AVKS_svb=true
			updateMerchButtons()
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Sell Vendor Button Enabled")
			end
		end
	end)
	
	--=================   Aardvark Sell Each Item Message   ====================
	local AVKS_eism_cb=CreateFrame("CheckButton","Aardvark_Sell_Each_Item_Message_Checkbox",AVKS_sop,"UICheckButtonTemplate")
	AVKS_eism_cb:ClearAllPoints()
	AVKS_eism_cb:SetParent(AVKS_e_cb)
	AVKS_eism_cb:SetPoint("BOTTOMRIGHT",AVKS_svb_cb,0,AVKSize.cbnxg)
	AVKS_eism_cb:SetSize(AVKSize.cbns,AVKSize.cbns)
	AVKS_eism_cb.text:SetText(" Detailed Sell Messages")
	AVKS_eism_cb.text:SetFontObject(AVKCBFontN)
	-- Aardvark mark checkbox display
	-- If Aardvark Sell is disabled hide checkbox
	if Aardvark_DB.AVKS_se==true and Aardvark_DB.AVKS_dsm==true then
		AVKS_eism_cb:SetChecked(true)
		AVKS_eism_cb:Show()
        elseif Aardvark_DB.AVKS_se==true and Aardvark_DB.AVKS_dsm==false then
		AVKS_eism_cb:SetChecked(false)
		AVKS_eism_cb:Show()
        elseif Aardvark_DB.AVKS_se==false and Aardvark_DB.AVKS_dsm==false then
		AVKS_eism_cb:SetChecked(false)
		AVKS_eism_cb:Hide()
        else
		AVKS_eism_cb:SetChecked(true)
		AVKS_eism_cb:Hide()
	end
	-- Aardvark checkbox function
	AVKS_eism_cb:SetScript("OnClick", function()
		if Aardvark_DB.AVKS_dsm==true then
			Aardvark_DB.AVKS_dsm=false
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Detailed Sell Messages Off")
			end
            else
			Aardvark_DB.AVKS_dsm=true
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Detailed Sell Messages On")
			end
		end
	end)
	
	--=================   Aardvark Sell Nothing To Sell Message   ===================
	local AVKS_ntsm_cb=CreateFrame("CheckButton","Aardvark_Nothing_To_Sell_Checkbox",AVKS_sop,"UICheckButtonTemplate")
	AVKS_ntsm_cb:ClearAllPoints()
	AVKS_ntsm_cb:SetParent(AVKS_e_cb)
	AVKS_ntsm_cb:SetPoint("BOTTOMRIGHT",AVKS_eism_cb,0,AVKSize.cbnxg)
	AVKS_ntsm_cb:SetSize(AVKSize.cbns,AVKSize.cbns)
	AVKS_ntsm_cb.text:SetText(" Nothing To Sell Messages")
	AVKS_ntsm_cb.text:SetFontObject(AVKCBFontN)
	-- Aardvark mark checkbox display
	-- If Aardvark Sell is disabled hide checkbox
	if Aardvark_DB.AVKS_se==true and Aardvark_DB.AVKS_ntsm==true then
		AVKS_ntsm_cb:SetChecked(true)
		AVKS_ntsm_cb:Show()
        elseif Aardvark_DB.AVKS_se==true and Aardvark_DB.AVKS_ntsm==false then
		AVKS_ntsm_cb:SetChecked(false)
		AVKS_ntsm_cb:Show()
        elseif Aardvark_DB.AVKS_se==false and Aardvark_DB.AVKS_ntsm==false then
		AVKS_ntsm_cb:SetChecked(false)
		AVKS_ntsm_cb:Hide()
        else
		AVKS_ntsm_cb:SetChecked(true)
		AVKS_ntsm_cb:Hide()
	end
	-- Aardvark checkbox function
	AVKS_ntsm_cb:SetScript("OnClick", function()
		if Aardvark_DB.AVKS_ntsm==true then
			Aardvark_DB.AVKS_ntsm=false
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Nothing to Sell Messages Disabled")
			end
            else
			Aardvark_DB.AVKS_ntsm=true
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Nothing to Sell Messages Enabled")
			end
		end
	end)
	
	--=============   Aardvark Sell Enable function   ======================
	--=========   built here to ensure the child checkboxes exist   ==========
	AVKS_e_cb:SetScript("OnClick",function()
		if Aardvark_DB.AVKS_se==true then
			AVKS_ea_cb:Hide()
			AVKS_svb_cb:Hide()
			AVKS_eism_cb:Hide()
			AVKS_ntsm_cb:Hide()
			Aardvark_DB.AVKS_se=false
			updateMerchButtons()
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Sell Disabled")
			end
            else
			Aardvark_DB.AVKS_se=true
			AVKS_ea_cb:Show()
			AVKS_svb_cb:Show()
			AVKS_eism_cb:Show()
			AVKS_ntsm_cb:Show()
			updateMerchButtons()
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Sell Enabled")
			end
		end
	end)
	
	--============================================================================
	--======================    AARDVARK SELL PANEL    ===========================
	--============================================================================
	
	--=================   Aardvark Sell Parent Panel    ======================
	local AVKS_sp = CreateFrame("Frame","Aardvark_Sell_Parent",AVK_mFrm)
	AVKS_sp:SetSize(AVKSize.mpw,AVKSize.mph)
	AVKS_sp:SetPoint("BOTTOM",0,AVKSize.mfbs)
	AVKS_sp:SetBackdrop( {nil, insets={}, tileSize=nil, tile=false, edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16 } )
	AVKS_sp:SetBackdropBorderColor(0,1,0,1)
	AVKS_sp:Hide()
	
	--=====================   Aardvark Sell Options Button    ======================
	local AVKS_soBtn=CreateFrame("Button","Aardvark_Sell_Options_Button",AVKS_sp,"UIMenuButtonStretchTemplate")
	AVKS_soBtn:SetSize(187,30)
	AVKS_soBtn:SetPoint("TOPLEFT",AVKS_sp,10,-10)
	AVKS_soBtn:SetBackdrop( { bgFile=nil, insets={left=4,right=4,top=4,bottom=4}, tileSize=16, tile=true, edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16 } )
	AVKS_soBtn:SetBackdropBorderColor(0,1,0,1)
	AVKS_soBtn:SetNormalFontObject(AVKCBFontN)
	AVKS_soBtn:SetHighlightFontObject(AVKCBFontN)
	AVKS_soBtn:SetFormattedText("Sell Options")
	AVKS_soBtn:SetScript("OnClick",function(self)
		sellOptionsButton()
	end)
	
	--=====================   Aardvark Clear Button   ======================
	local AVKS_scslBtn=CreateFrame("Button","Aardvark_Clear_Sell_List_Button",AVKS_sp,"UIMenuButtonStretchTemplate")
	AVKS_scslBtn:SetSize(187,30)
	AVKS_scslBtn:SetPoint("TOPLEFT",AVKS_soBtn,"BOTTOMLEFT",0,-8)
	AVKS_scslBtn:SetBackdrop( { bgFile=nil, insets={left=4,right=4,top=4,bottom=4}, tileSize=16, tile=true, edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16 } )
	AVKS_scslBtn:SetBackdropBorderColor(0,1,0,1)
	AVKS_scslBtn:SetNormalFontObject(AVKCBFontN)
	AVKS_scslBtn:SetHighlightFontObject(AVKCBFontN)
	AVKS_scslBtn:SetFormattedText("Clear Sell List")
	AVKS_scslBtn:RegisterForClicks("MiddleButtonUp")
	
	AVKS_scslBtn:SetScript("OnClick",function(self)
		cleanAVKS_DB()
		if Aardvark_DB.AVK_asm==true then
			print(AVKFont.fbp.."Sell List Cleared")
		end
	end)
	
	--=====================   Aardvark Sell Drop Box    ======================
	local AVKS_db=CreateFrame("Button","Aardvark_Sell_Drop_Box",AVKS_sp,"ItemButtonTemplate")
	--    AVKS_db:SetScale(1.8)
	AVKS_db:SetSize(70,70)
	AVKS_db:SetPoint("TOPRIGHT",-9,-9)
	AVKS_db:SetBackdrop( { bgFile="Interface\\DialogFrame\\UI-DialogBox-Background", insets={left=4,right=4,top=4,bottom=4}, tileSize=nil, tile=nil, edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 20 } )
	AVKS_db:SetNormalTexture(nil)
	AVKS_db:SetBackdropBorderColor(0,1,0,1)
	-- Aardvark Sell Drop Box Drag and Drop Script
	AVKS_db:SetScript("OnReceiveDrag",function()
		AVK_addItemToList()
	end)
	-- Aardvark Sell Drop Box Click Script
	AVKS_db:SetScript("OnClick",function()
		if GetCursorInfo() then
			AVK_addItemToList()
		end
	end)
	
	--=====================   Aardvark Sell Scroll Frame Parent   ======================
	local AVKS_sfp = CreateFrame("Frame","Aardvark_Sell_Scroll_Frame_Parent",AVKS_sp)
	AVKS_sfp:SetSize(AVKSize.mpw-AVKSize.mfs,AVKSize.sph)
	AVKS_sfp:SetPoint("TOPLEFT",AVKS_scslBtn,"BOTTOMLEFT",0,-8)
	AVKS_sfp:SetBackdrop( { bgFile="Interface\\DialogFrame\\UI-DialogBox-Background", insets={left=4,right=4,top=4,bottom=4}, tileSize=16, tile=true, edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16 } )
	AVKS_sfp:SetBackdropBorderColor(0,1,0,1)
	
	--=====================   Aardvark Sell Scroll Frame Child    ======================
	local AVKS_sfc = CreateFrame("ScrollFrame","Aardvark_Sell_Scroll_Frame_Child",AVKS_sfp,"FauxScrollFrameTemplate")
	AVKS_sfc:SetPoint("TOPLEFT",0,-8)
	AVKS_sfc:SetPoint("BOTTOMRIGHT",-30,8)
	AVKS_sfc:SetScript("OnVerticalScroll",function(self,offset)
		FauxScrollFrame_OnVerticalScroll(self, offset, AVKSize.sbh, AVKS_sellUpdate)
	end)
	
	--============    Aardvark Sell Scroll Frame Child Button Table   ==============
	AVKS_sfc.sBtnT = {}
	for avkSindex=1,AVKSize.sbn do
		AVKS_sfc.sBtnT[avkSindex] = CreateFrame("Button","Aardvark_Sell_Scroll_Frame_Button"..avkSindex,AVKS_sfp)
		local AVKS_sBtn = AVKS_sfc.sBtnT[avkSindex]
		AVKS_sBtn:SetSize(AVKSize.mpw-AVKSize.mft,AVKSize.sbh)
		--      AVKS_sBtn:SetScale(.90)    --   DebugTestPrint
		AVKS_sBtn:SetNormalFontObject("GameFontHighlightLeft")
		AVKS_sBtn:SetPoint("TOPLEFT",8,-(avkSindex-1)*AVKSize.sbh-8)
		AVKS_sBtn:SetHighlightTexture("Interface\\BUTTONS\\UI-Listbox-Highlight2")
		AVKS_sBtn:SetScript("OnEnter",function(self)
			local itemName,itemLink,_,_,_,_,_,_,_,_,_ = GetItemInfo(Aardvark_Sell_DB[self.index])
			GameTooltip:SetOwner(self,"ANCHOR_LEFT",-22,-8)
			GameTooltip:SetHyperlink(itemLink)
			GameTooltip:SetScale(.85)
			if Aardvark_DB.AVK_alit==true then
				GameTooltip:Show()
                else
				GameTooltip:Hide()
			end
		end)
		AVKS_sBtn:SetScript("OnLeave",function(self)
			GameTooltip:SetScale(1)
			GameTooltip:Hide()
		end)
		AVKS_sBtn:SetScript("OnClick",function(self)
			table.remove(Aardvark_Sell_DB,self.index)
			AVKS_sellUpdate()
		end)
	end
	
	--============================================================================
	--==================     AARDVARK SELL FUNCTIONS    ==========================
	--============================================================================
	
	--======================    Aardvark Sell       ======================
	function AVKS_sell()
		local vGuid, vName = UnitGUID("target"), UnitName("target")
		local _, _, _, _, _, npcID, _ = strsplit("-",vGuid)
		local vID = tonumber(npcID)
		if AVK_checkVendorChecklist(vID) then -- Check if vendor ID is on blacklist
			print(AVKFont.fbpc..AVKFont.fg..vName.." refuses to buy your items.")
            else
			local AVKS_profit=0   -- Cash counting variable
			for sBag=0,4 do   -- Check each bag
				local sBagSlots = GetContainerNumSlots(sBag)
				for sSlot=0,sBagSlots do    -- Check each bag slot
					local sCurrentItemID = GetContainerItemID(sBag,sSlot)
					if sCurrentItemID then-- If current bag slot has an item then get the item info
						local _,sItemLink,sItemQuality,_,_,_,_,_,_,_,sItemValue=GetItemInfo(sCurrentItemID)
						local _,sItemCount,_,_,_,_,_,_=GetContainerItemInfo(sBag,sSlot)
						if sItemQuality==0 or AVKS_itemOnSellList(sCurrentItemID)==true then    -- if the current Item quality is grey or item on sell list
							_,sItemCount=GetContainerItemInfo(sBag,sSlot)   -- count how many of the item is in the current bag slot
							AVKS_profit=AVKS_profit+(sItemValue*sItemCount)
							-- if item sell messages are on print (this message can be disabled)
							if Aardvark_DB.AVKS_dsm==true then     -- Print each item sold
								print(" - Sold: "..sItemCount.." "..sItemLink.." for "..GetCoinTextureString(sItemValue*sItemCount))
							end
							UseContainerItem(sBag,sSlot)  -- sell current items
						end
					end
				end
			end
			if AVKS_profit~=0 then    -- if items were sold print out total -- if no items sell print out grind message (these messages cannot be disabled)
				print(AVKFont.fbpc..AVKFont.fg.."Total Profit :-|r  "..GetCoinTextureString(AVKS_profit))
                elseif Aardvark_DB.AVKS_ntsm==true then
				print(AVKFont.fbpc..AVKFont.fg.."Nothing to sell. Better grind some more.")
			end
		end
	end
	
	--===============   Aardvark Item On Sell List Check    =================
	function AVKS_itemOnSellList(CurrentItem)
		for k, v in pairs (Aardvark_Sell_DB) do
			if (v==CurrentItem) then
				return true
			end
		end
		return false
	end
	
	--===============   Aardvark Sell Update Scroll Frame   ==================
	function AVKS_sellUpdate()
		FauxScrollFrame_Update(AVKS_sfc,#Aardvark_Sell_DB,AVKSize.sbn,AVKSize.sbh)
		for index = 1,AVKSize.sbn do
			local offset = index + FauxScrollFrame_GetOffset(AVKS_sfc)
			local AVKS_sBtn = AVKS_sfc.sBtnT[index]
			AVKS_sBtn.index = offset
			if offset<=#Aardvark_Sell_DB then
				local itemName,itemLink,_,_,_,_,_,_,_,_,_ = GetItemInfo(Aardvark_Sell_DB[offset])
				AVKS_sBtn:SetText(itemLink)
				AVKS_sBtn:Show()
                else
				AVKS_sBtn:Hide()
			end
		end
	end
	
	--===============   Aardvark Vendor on Blacklist Check    =================
	function AVK_checkVendorChecklist(CurrentVendor)
		for k, v in pairs (AVKVendorBlacklist) do
			if (v==CurrentVendor) then
				return true
			end
		end
		return false
	end
	
	--==================  Aardvark Sell Vendor Button    ==================
	local AVKS_sVenBtn=CreateFrame("Button","Aardvark_Destroy_Vendor_Button",MerchantFrame)
	AVKS_sVenBtn:SetSize(24,24)
	AVKS_sVenBtn:SetPoint("LEFT",AVK_aMercBtn,30,0)
	AVKS_sVenBtn:SetNormalTexture(AVKImg.avki_alt)
	AVKS_sVenBtn:SetHighlightTexture(AVKImg.avksi_alt,"BLEND")
	AVKS_sVenBtn:RegisterForClicks("LeftButtonUp")
	-- Aardvark Sell Vendor Button on-click function
	AVKS_sVenBtn:SetScript("Onclick",function()
		AVKS_sell()
	end)
	-- Aardvark show Sell Vendor Button on-click function
	AVKS_sVenBtn:SetScript("OnEvent",function(self,event,...)
		-- If Sell is enabled & Auto Sell is enabled - Sell
		if Aardvark_DB.AVKS_se==true and Aardvark_DB.AVKS_as==true then
			AVKS_sell()
		end
		updateMerchButtons()
	end)
	AVKS_sVenBtn:RegisterEvent("MERCHANT_SHOW")
	
	--============================================================================
	--===============      AARDVARK DESTROY OPTIONS PANEL     ====================
	--============================================================================
	
	--=================   Aardvark Destroy Options Parent Panel    ======================
	local AVKD_dop = CreateFrame("Frame","Aardvark_Destroy_Options_Parent",AVK_mFrm)
	AVKD_dop:SetSize(AVKSize.mpw,AVKSize.mph)
	AVKD_dop:SetPoint("BOTTOM",0,AVKSize.mfbs)
	AVKD_dop:SetBackdrop( {nil, insets={}, tileSize=nil, tile=false, edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16 } )
	AVKD_dop:SetBackdropBorderColor(1,0,0,1)
	AVKD_dop:Hide()
	
	--============================================================================
	--===================      AARDVARK DESTROY OPTIONS      =====================
	--============================================================================
	
	--=====================   Aardvark Destroy Enable    ======================
	local AVKD_e_cb=CreateFrame("CheckButton","Aardvark_Destroy_Checkbox",AVKD_dop,"UICheckButtonTemplate")
	AVKD_e_cb:ClearAllPoints()
	AVKD_e_cb:SetPoint("TOPLEFT",AVKSize.cbfxg,AVKSize.cbfyg)
	AVKD_e_cb:SetSize(AVKSize.cbbs,AVKSize.cbbs)
	AVKD_e_cb.text:SetText(AVKFont.fr.."Enable Aardvark Destroy|r")
	AVKD_e_cb.text:SetFontObject(AVKCBFontB)
	-- Aardvark mark checkbox display
	if Aardvark_DB.AVKD_de==true then
		AVKD_e_cb:SetChecked(true)
        else
		AVKD_e_cb:SetChecked(false)
	end
	
	--=================   Aardvark Auto Destroy   ====================
	local AVKD_ad_cb=CreateFrame("CheckButton","Aardvark_Auto_Destroy_Checkbox",AVKD_dop,"UICheckButtonTemplate")
	AVKD_ad_cb:ClearAllPoints()
	AVKD_ad_cb:SetParent(AVKD_e_cb)
	AVKD_ad_cb:SetPoint("BOTTOMRIGHT",AVKD_e_cb,AVKSize.cbcyg,AVKSize.cbnxg)
	AVKD_ad_cb:SetSize(AVKSize.cbns,AVKSize.cbns)
	AVKD_ad_cb.text:SetText(" Enable Auto Destroy")
	AVKD_ad_cb.text:SetFontObject(AVKCBFontN)
	-- Aardvark mark checkbox display
	-- If Aardvark Destroy is disabled hide checkbox
	if Aardvark_DB.AVKD_de==true and Aardvark_DB.AVKD_ad==true then
		AVKD_ad_cb:SetChecked(true)
		AVKD_ad_cb:Show()
        elseif Aardvark_DB.AVKD_de==true and Aardvark_DB.AVKD_ad==false then
		AVKD_ad_cb:SetChecked(false)
		AVKD_ad_cb:Show()
        elseif Aardvark_DB.AVKD_de==false and Aardvark_DB.AVKD_ad==false then
		AVKD_ad_cb:SetChecked(false)
		AVKD_ad_cb:Hide()
        else
		AVKD_ad_cb:SetChecked(true)
		AVKD_ad_cb:Hide()
	end
	-- Aardvark checkbox function
	AVKD_ad_cb:SetScript("OnClick", function()
		if Aardvark_DB.AVKD_ad==true then
			Aardvark_DB.AVKD_ad=false
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Auto Destroy Disabled")
			end
            else
			Aardvark_DB.AVKD_ad=true
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Auto Destroy Enabled")
			end
		end
	end)
	
	--=================   Aardvark Destroy Vendor Button   ===================
	local AVKD_mfb_cb=CreateFrame("CheckButton","Aardvark_Destroy_Merchant_Button_Checkbox",AVKD_dop,"UICheckButtonTemplate")
	AVKD_mfb_cb:ClearAllPoints()
	AVKD_mfb_cb:SetParent(AVKD_e_cb)
	AVKD_mfb_cb:SetPoint("BOTTOMRIGHT",AVKD_ad_cb,0,AVKSize.cbnxg)
	AVKD_mfb_cb:SetSize(AVKSize.cbns,AVKSize.cbns)
	AVKD_mfb_cb.text:SetText(" Destroy Vendor Button")
	AVKD_mfb_cb.text:SetFontObject(AVKCBFontN)
	-- Aardvark mark checkbox display
	-- If Aardvark Destroy is disabled hide checkbox
	if Aardvark_DB.AVKD_de==true and Aardvark_DB.AVKD_dvb==true then
		AVKD_mfb_cb:SetChecked(true)
		AVKD_mfb_cb:Show()
		elseif Aardvark_DB.AVKD_de==true and Aardvark_DB.AVKD_dvb==false then
		AVKD_mfb_cb:SetChecked(false)
		AVKD_mfb_cb:Show()
		elseif Aardvark_DB.AVKD_de==false and Aardvark_DB.AVKD_dvb==false then
		AVKD_mfb_cb:SetChecked(false)
		AVKD_mfb_cb:Hide()
		else
		AVKD_mfb_cb:SetChecked(true)
		AVKD_mfb_cb:Hide()
	end
	-- Aardvark checkbox function
	AVKD_mfb_cb:SetScript("OnClick", function()
		if Aardvark_DB.AVKD_dvb==true then
			Aardvark_DB.AVKD_dvb=false
			updateMerchButtons()
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Destroy Vendor Button Disabled")
			end
			else
			Aardvark_DB.AVKD_dvb=true
			updateMerchButtons()
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Destroy Vendor Button Enabled")
			end
		end
	end)
	
	--=================   Aardvark Destroy Each Item Message   ====================
	local AVKD_eidm_cb=CreateFrame("CheckButton","Aardvark_Detailed_Destroy_Message_Checkbox",AVKD_dop,"UICheckButtonTemplate")
	AVKD_eidm_cb:ClearAllPoints()
	AVKD_eidm_cb:SetParent(AVKD_e_cb)
	AVKD_eidm_cb:SetPoint("BOTTOMRIGHT",AVKD_mfb_cb,0,AVKSize.cbnxg)
	AVKD_eidm_cb:SetSize(AVKSize.cbns,AVKSize.cbns)
	AVKD_eidm_cb.text:SetText(" Detailed Destroy Messages")
	AVKD_eidm_cb.text:SetFontObject(AVKCBFontN)
	-- Aardvark mark checkbox display
	-- If Aardvark Destroy is disabled hide checkbox
	if Aardvark_DB.AVKD_de==true and Aardvark_DB.AVKD_ddm==true then
		AVKD_eidm_cb:SetChecked(true)
		AVKD_eidm_cb:Show()
		elseif Aardvark_DB.AVKD_de==true and Aardvark_DB.AVKD_ddm==false then
		AVKD_eidm_cb:SetChecked(false)
		AVKD_eidm_cb:Show()
		elseif Aardvark_DB.AVKD_de==false and Aardvark_DB.AVKD_ddm==false then
		AVKD_eidm_cb:SetChecked(false)
		AVKD_eidm_cb:Hide()
		else
		AVKD_eidm_cb:SetChecked(true)
		AVKD_eidm_cb:Hide()
	end
	-- Aardvark checkbox function
	AVKD_eidm_cb:SetScript("OnClick", function()
		if Aardvark_DB.AVKD_ddm==true then
			Aardvark_DB.AVKD_ddm=false
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Detailed Destroy Messages Disabled")
			end
			else
			Aardvark_DB.AVKD_ddm=true
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Detailed Destroy Messages Enabled")
			end
		end
	end)
	
	--=================   Aardvark Destroy Nothing To Destroy Message   ===================
	local AVKD_ntdm_cb=CreateFrame("CheckButton","Aardvark_Zero_To_Destroy_Checkbox",AVKD_dop,"UICheckButtonTemplate")
	AVKD_ntdm_cb:ClearAllPoints()
	AVKD_ntdm_cb:SetParent(AVKD_e_cb)
	AVKD_ntdm_cb:SetPoint("BOTTOMRIGHT",AVKD_eidm_cb,0,AVKSize.cbnxg)
	AVKD_ntdm_cb:SetSize(AVKSize.cbns,AVKSize.cbns)
	AVKD_ntdm_cb.text:SetText(" Nothing To Destroy Messages")
	AVKD_ntdm_cb.text:SetFontObject(AVKCBFontN)
	-- Aardvark mark checkbox display
	-- If Aardvark Destroy is disabled hide checkbox
	if Aardvark_DB.AVKD_de==true and Aardvark_DB.AVKD_ntdm==true then
		AVKD_ntdm_cb:SetChecked(true)
		AVKD_ntdm_cb:Show()
		elseif Aardvark_DB.AVKD_de==true and Aardvark_DB.AVKD_ntdm==false then
		AVKD_ntdm_cb:SetChecked(false)
		AVKD_ntdm_cb:Show()
		elseif Aardvark_DB.AVKD_de==false and Aardvark_DB.AVKD_ntdm==false then
		AVKD_ntdm_cb:SetChecked(false)
		AVKD_ntdm_cb:Hide()
		else
		AVKD_ntdm_cb:SetChecked(true)
		AVKD_ntdm_cb:Hide()
	end
	-- Aardvark checkbox function
	AVKD_ntdm_cb:SetScript("OnClick", function()
		if Aardvark_DB.AVKD_ntdm==true then
			Aardvark_DB.AVKD_ntdm=false
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Nothing To Destroy Messages Disabled")
			end
			else
			Aardvark_DB.AVKD_ntdm=true
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Nothing To Destroy Messages Enabled")
			end
		end
	end)
	
	--=============   Aardvark Destroy Enable function   ======================
	--=========   built here to ensure the child checkboxes exist   ==========
	AVKD_e_cb:SetScript("OnClick",function()
		if Aardvark_DB.AVKD_de==true then
			AVKD_ad_cb:Hide()
			AVKD_mfb_cb:Hide()
			AVKD_eidm_cb:Hide()
			AVKD_ntdm_cb:Hide()
			Aardvark_DB.AVKD_de=false
			updateMerchButtons()
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Destroy Disabled")
			end
			else
			Aardvark_DB.AVKD_de=true
			AVKD_ad_cb:Show()
			AVKD_mfb_cb:Show()
			AVKD_eidm_cb:Show()
			AVKD_ntdm_cb:Show()
			updateMerchButtons()
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Destroy Enabled")
			end
		end
	end)
	
	--=====================   Aardvark Destroy Text   ======================
	local AVKD_dText = CreateFrame("Frame","Aardvark_Destroy_Text_Frame",AVKD_dop)
	AVKD_dText:SetSize(AVKSize.mpw-AVKSize.mfs,AVKSize.sph/10*8)
	AVKD_dText:SetPoint("BOTTOM",0,10)
	AVKD_dTxtC=AVKD_dText:CreateFontString("Aardvark_Destroy_Text")
	AVKD_dTxtC:SetPoint("TOP",0,-26)
	AVKD_dTxtC:SetJustifyH("left")
	AVKD_dTxtC:SetAllPoints(AVKD_dText)
	AVKD_dTxtC:SetFontObject(AVKCFont)
	AVKD_dTxtC:SetText(AVKText.dot)
	
	--============================================================================
	--====================    AARDVARK DESTROY PANEL    ==========================
	--============================================================================
	
	--=================   Aardvark Destroy Parent Panel    ======================
	local AVKD_dp = CreateFrame("Frame","Aardvark_Destroy_Parent",AVK_mFrm)
	AVKD_dp:SetSize(AVKSize.mpw,AVKSize.mph)
	AVKD_dp:SetPoint("BOTTOM",0,AVKSize.mfbs)
	AVKD_dp:SetBackdrop( {nil, insets={}, tileSize=nil, tile=false, edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16 } )
	AVKD_dp:SetBackdropBorderColor(1,0,0,1)
	AVKD_dp:Hide()
	
	--=====================   Aardvark Destroy Options Button   ======================
	local AVKD_doBtn=CreateFrame("Button","Aardvark_Destroy_Options_Button",AVKD_dp,"UIMenuButtonStretchTemplate")
	AVKD_doBtn:SetSize(187,30)
	AVKD_doBtn:SetPoint("TOPLEFT",AVKD_dp,10,-10)
	AVKD_doBtn:SetBackdrop( { bgFile=nil, insets={left=4,right=4,top=4,bottom=4}, tileSize=16, tile=true, edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16 } )
	AVKD_doBtn:SetBackdropBorderColor(1,0,0,1)
	AVKD_doBtn:SetNormalFontObject(AVKCBFontN)
	AVKD_doBtn:SetHighlightFontObject(AVKCBFontN)
	AVKD_doBtn:SetFormattedText("Destroy Options")
	AVKD_doBtn:SetScript("OnClick",function(self)
		destroyOptionsButton()
	end)
	
	--=====================   Aardvark Clear Button   ======================
	local AVKD_dcdlBtn=CreateFrame("Button","Aardvark_Clear_Destroy_List_Button",AVKD_dp,"UIMenuButtonStretchTemplate")
	AVKD_dcdlBtn:SetSize(187,30)
	AVKD_dcdlBtn:SetPoint("TOPLEFT",AVKD_doBtn,"BOTTOMLEFT",0,-8)
	AVKD_dcdlBtn:SetBackdrop( { bgFile="Interface\\DialogFrame\\UI-DialogBox-Background", insets={left=4,right=4,top=4,bottom=4}, tileSize=16, tile=true, edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16 } )
	AVKD_dcdlBtn:SetBackdropBorderColor(1,0,0,1)
	AVKD_dcdlBtn:SetNormalFontObject(AVKCBFontN)
	AVKD_dcdlBtn:SetHighlightFontObject(AVKCBFontN)
	AVKD_dcdlBtn:SetFormattedText("Clear Destroy List")
	AVKD_dcdlBtn:RegisterForClicks("MiddleButtonUp")
	
	AVKD_dcdlBtn:SetScript("OnClick",function(self)
		cleanAVKD_DB()
		if Aardvark_DB.AVK_asm==true then
			print(AVKFont.fbp.."Destroy List Cleared")
		end
	end)
	
	--=====================   Aardvark Destroy Drop Box    ======================
	local AVKD_db=CreateFrame("Button","Aardvark_Destroy_Drop_Box",AVKD_dp,"ItemButtonTemplate")
	AVKD_db:SetSize(70,70)
	AVKD_db:SetPoint("TOPRIGHT",-9,-9)
	AVKD_db:SetBackdrop( { bgFile="Interface\\DialogFrame\\UI-DialogBox-Background", insets={left=4,right=4,top=4,bottom=4}, tileSize=16, tile=true, edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 20 } )
	AVKD_db:SetNormalTexture(nil)
	AVKD_db:SetBackdropBorderColor(1,0,0,1)
	-- Aardvark Destroy Drop Box Drag and Drop Script
	AVKD_db:SetScript("OnReceiveDrag",function()
		AVK_addItemToList()
	end)
	-- Aardvark Destroy Drop Box Click Script
	AVKD_db:SetScript("OnClick",function()
		if GetCursorInfo() then
			AVK_addItemToList()
		end
	end)
	
	--=====================   Aardvark Destroy Scroll Frame Parent   ======================
	local AVKD_sfp = CreateFrame("Frame","Aardvark_Destroy_Scroll_Frame_Parent",AVKD_dp)
	AVKD_sfp:SetSize(AVKSize.mpw-AVKSize.mfs,AVKSize.sph)
	AVKD_sfp:SetPoint("TOPLEFT",AVKD_dcdlBtn,"BOTTOMLEFT",0,-8)
	AVKD_sfp:SetBackdrop( { bgFile="Interface\\DialogFrame\\UI-DialogBox-Background", insets={left=4,right=4,top=4,bottom=4}, tileSize=16, tile=true, edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16 } )
	AVKD_sfp:SetBackdropBorderColor(1,0,0,1)
	
	--=====================   Aardvark Destroy Scroll Frame Child    ======================
	local AVKD_sfc = CreateFrame("ScrollFrame","Aardvark_Destroy_Scroll_Frame_Child",AVKD_sfp,"FauxScrollFrameTemplate")
	AVKD_sfc:SetPoint("TOPLEFT",0,-8)
	AVKD_sfc:SetPoint("BOTTOMRIGHT",-30,8)
	AVKD_sfc:SetScript("OnVerticalScroll",function(self,offset)
		FauxScrollFrame_OnVerticalScroll(self, offset, AVKSize.sbh, AVKD_destroyUpdate)
	end)
	
	--============    Aardvark Destroy Scroll Frame Child Button Table   ==============
	AVKD_sfc.dBtnT = {}
	for avkDindex=1,AVKSize.sbn do
		AVKD_sfc.dBtnT[avkDindex] = CreateFrame("Button","Aardvark_Destroy_Scroll_Frame_Button"..avkDindex,AVKD_sfp)
		local AVKD_dBtn = AVKD_sfc.dBtnT[avkDindex]
		AVKD_dBtn:SetSize(AVKSize.mpw-AVKSize.mft,AVKSize.sbh)
		AVKD_dBtn:SetNormalFontObject("GameFontHighlightLeft")
		AVKD_dBtn:SetPoint("TOPLEFT",8,-(avkDindex-1)*AVKSize.sbh-8)
		AVKD_dBtn:SetHighlightTexture("Interface\\BUTTONS\\UI-Listbox-Highlight2")
		AVKD_dBtn:SetScript("OnEnter",function(self)
			
			local itemName,itemLink,_,_,_,_,_,_,_,_,_ = GetItemInfo(Aardvark_Destroy_DB[self.index])
			GameTooltip:SetOwner(self,"ANCHOR_LEFT",-22,-8)
			GameTooltip:SetHyperlink(itemLink)
			GameTooltip:SetScale(.85)
			if Aardvark_DB.AVK_alit==true then
				GameTooltip:Show()
				else
				GameTooltip:Hide()
			end
		end)
		AVKD_dBtn:SetScript("OnLeave",function(self)
			GameTooltip:SetScale(1)
			GameTooltip:Hide()
		end)
		AVKD_dBtn:SetScript("OnClick",function(self)
			table.remove(Aardvark_Destroy_DB,self.index)
			AVKD_destroyUpdate()
		end)
	end
	
	--============================================================================
	--=====================   AARDVARK DESTROY FUNCTIONS    ======================
	--============================================================================
	
	--======================    Aardvark Destroy       ======================
	function AVKD_destroy()
		if Aardvark_DB.AVKD_de==true then
			local AVKD_destroyedItemNum=0   -- destroyed items counting variable
			local AVKD_destroyedSlotNum=0
			for dBag=0,4 do   -- Check each bag
				local dBagSlots = GetContainerNumSlots(dBag)
				for dSlot=0,dBagSlots do    -- Check each bag slot
					local dCurrentItemID = GetContainerItemID(dBag,dSlot)
					if dCurrentItemID then-- If current bag slot has an item then get the item info
						local _,dItemLink,_,_,_,_,_,_,_,_,_=GetItemInfo(dCurrentItemID)
						local _,dItemCount,_,_,_,_,_,_=GetContainerItemInfo(dBag,dSlot)
						if AVKD_itemOnDestroyList(dCurrentItemID)==true then    -- if the current item is on destroy list
							_,dItemCount=GetContainerItemInfo(dBag,dSlot)   -- count how many of the item is in the current bag slot
							AVKD_destroyedItemNum=AVKD_destroyedItemNum+dItemCount
							AVKD_destroyedSlotNum=AVKD_destroyedSlotNum+1
							-- if item Destroy messages are on print (this message can be disabled)
							if Aardvark_DB.AVKD_ddm==true then     -- Print each item destroyed
								print(" - Destroyed: "..dItemCount.." "..dItemLink)
							end
							PickupContainerItem(dBag,dSlot) DeleteCursorItem()  -- Destroy current item
						end
					end
				end
			end
			if AVKD_destroyedSlotNum~=0 then    -- if items were destroyed print out total -- if no items destroyed print out bag space message
				print(AVKFont.fbpc..AVKFont.fr.."Items destroyed :-|r "..AVKD_destroyedItemNum..AVKFont.fr.."  ~  Bagslots cleared :-|r "..AVKD_destroyedSlotNum)
				elseif Aardvark_DB.AVKD_ntdm==true then
				print(AVKFont.fbpc..AVKFont.fr.."Nothing destroyed. No bag space saved.")
			end
		end
	end
	
	--===============   Aardvark Item On Destroy List Check    =================
	function AVKD_itemOnDestroyList(CurrentItem)
		for k, v in pairs (Aardvark_Destroy_DB) do
			if (v==CurrentItem) then
				return true
			end
		end
		return false
	end
	
	--===============   Aardvark Destroy Update Scroll Frame   ==================
	function AVKD_destroyUpdate()
		FauxScrollFrame_Update(AVKD_sfc,#Aardvark_Destroy_DB,AVKSize.sbn,AVKSize.sbh)
		for index = 1,AVKSize.sbn do
			local offset = index + FauxScrollFrame_GetOffset(AVKD_sfc)
			local AVKD_dBtn = AVKD_sfc.dBtnT[index]
			AVKD_dBtn.index = offset
			if offset<=#Aardvark_Destroy_DB then
				local itemName,itemLink,_,_,_,_,_,_,_,_,_ = GetItemInfo(Aardvark_Destroy_DB[offset])
				AVKD_dBtn:SetText(itemLink)
				AVKD_dBtn:Show()
				else
				AVKD_dBtn:Hide()
			end
		end
	end
	
	--==================  Aardvark Destroy Vendor Button    ==================
	local AVKD_dVenBtn=CreateFrame("Button","Aardvark_Destroy_Vendor_Button",MerchantFrame)
	AVKD_dVenBtn:SetSize(24,24)
	AVKD_dVenBtn:SetPoint("LEFT",AVKS_sVenBtn,30,0)
	AVKD_dVenBtn:SetNormalTexture(AVKImg.avkdi)
	AVKD_dVenBtn:SetHighlightTexture(AVKImg.avkdi_alt,"BLEND")
	AVKD_dVenBtn:RegisterForClicks("RightButtonUp")
	-- Aardvark Destroy Vendor Button on-click function
	AVKD_dVenBtn:SetScript("Onclick",function()
		AVKD_destroy()
	end)
	-- Aardvark show Destroy Vendor Button on-click function
	AVKD_dVenBtn:SetScript("OnEvent",function(self,event,...)
		-- If Destroy is enabled & Auto Destroy is enabled - Destroy
		if Aardvark_DB.AVKD_de==true and Aardvark_DB.AVKD_ad==true then
			AVKD_destroy()
		end
		updateMerchButtons()
	end)
	AVKD_dVenBtn:RegisterEvent("MERCHANT_SHOW")
	
	--============================================================================
	--==================      AARDVARK REPAIR OPTIONS PANEL     ====================
	--============================================================================
	
	--=================   Aardvark Repair Options Parent Panel    ======================
	local AVKR_rop = CreateFrame("Frame","Aardvark_Repair_Options_Parent",AVK_mFrm)
	AVKR_rop:SetSize(AVKSize.mpw,AVKSize.mph)
	AVKR_rop:SetPoint("BOTTOM",0,AVKSize.mfbs)
	AVKR_rop:SetBackdrop( {nil, insets={}, tileSize=nil, tile=false, edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16 } )
	AVKR_rop:SetBackdropBorderColor(1,0,1,1)
	AVKR_rop:Hide()
	
	--============================================================================
	--=====================     AARDVARK REPAIR OPTIONS    =======================
	--============================================================================
	
	--=====================   Aardvark Repair Enable    ======================
	local AVKR_e_cb=CreateFrame("CheckButton","Aardvark_Repair_Checkbox",AVKR_rop,"UICheckButtonTemplate")
	AVKR_e_cb:ClearAllPoints()
	AVKR_e_cb:SetPoint("TOPLEFT",AVKSize.cbfxg,AVKSize.cbfyg)
	AVKR_e_cb:SetSize(AVKSize.cbbs,AVKSize.cbbs)
	AVKR_e_cb.text:SetText(AVKFont.fp.."Enable Aardvark Repair")
	AVKR_e_cb.text:SetFontObject(AVKCBFontB)
	-- Aardvark mark checkbox display
	if Aardvark_DB.AVKR_re==true then
		AVKR_e_cb:SetChecked(true)
		else
		AVKR_e_cb:SetChecked(false)
	end
	
	--=====================     Aardvark Guild Repair   ======================
	local AVKR_gr_cb=CreateFrame("CheckButton","Aardvark_Guild_Repair_Checkbox",AVKR_rop,"UICheckButtonTemplate")
	AVKR_gr_cb:ClearAllPoints()
	AVKR_gr_cb:SetParent(AVKR_e_cb)
	AVKR_gr_cb:SetPoint("BOTTOMRIGHT",AVKR_e_cb,AVKSize.cbcyg,AVKSize.cbnxg)
	AVKR_gr_cb:SetSize(AVKSize.cbns,AVKSize.cbns)
	AVKR_gr_cb.text:SetText(" Enable Guild Repair")
	AVKR_gr_cb.text:SetFontObject(AVKCBFontN)
	-- Aardvark mark checkbox display
	-- If Aardvark Repair is disabled hide checkbox
	if Aardvark_DB.AVKR_re==true and Aardvark_DB.AVKR_rgr==true then
		AVKR_gr_cb:SetChecked(true)
		AVKR_gr_cb:Show()
		elseif Aardvark_DB.AVKR_re==true and Aardvark_DB.AVKR_rgr==false then
		AVKR_gr_cb:SetChecked(false)
		AVKR_gr_cb:Show()
		elseif Aardvark_DB.AVKR_re==false and Aardvark_DB.AVKR_rgr==false then
		AVKR_gr_cb:SetChecked(false)
		AVKR_gr_cb:Hide()
		else
		AVKR_gr_cb:SetChecked(true)
		AVKR_gr_cb:Hide()
	end
	-- Aardvark checkbox function
	AVKR_gr_cb:SetScript("OnClick", function()
		if Aardvark_DB.AVKR_rgr==true then
			Aardvark_DB.AVKR_rgr=false
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Guild Repair Disabled")
			end
			else
			Aardvark_DB.AVKR_rgr=true
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Guild Repair Enabled")
			end
		end
	end)
	
	--=================   Aardvark Repair Not Required Message    ====================
	local AVKR_rnrm_cb=CreateFrame("CheckButton","Aardvark_Repair_Not_Required_Checkbox",AVKR_rop,"UICheckButtonTemplate")
	AVKR_rnrm_cb:ClearAllPoints()
	AVKR_rnrm_cb:SetParent(AVKR_e_cb)
	AVKR_rnrm_cb:SetPoint("BOTTOMRIGHT",AVKR_gr_cb,0,AVKSize.cbnxg)
	AVKR_rnrm_cb:SetSize(AVKSize.cbns,AVKSize.cbns)
	AVKR_rnrm_cb.text:SetText(" Repair Not Required Messages")
	AVKR_rnrm_cb.text:SetFontObject(AVKCBFontN)
	-- Aardvark mark checkbox display
	-- If Aardvark Repair is disabled hide checkbox
	if Aardvark_DB.AVKR_re==true and Aardvark_DB.AVKR_rnrm==true then
		AVKR_rnrm_cb:SetChecked(true)
		AVKR_rnrm_cb:Show()
		elseif Aardvark_DB.AVKR_re==true and Aardvark_DB.AVKR_rnrm==false then
		AVKR_rnrm_cb:SetChecked(false)
		AVKR_rnrm_cb:Show()
		elseif Aardvark_DB.AVKR_re==false and Aardvark_DB.AVKR_rnrm==false then
		AVKR_rnrm_cb:SetChecked(false)
		AVKR_rnrm_cb:Hide()
		else
		AVKR_rnrm_cb:SetChecked(true)
		AVKR_rnrm_cb:Hide()
	end
	-- Aardvark checkbox function
	AVKR_rnrm_cb:SetScript("OnClick", function()
		if Aardvark_DB.AVKR_rnrm==true then
			Aardvark_DB.AVKR_rnrm=false
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Repair Not Required Messages Disabled")
			end
			else
			Aardvark_DB.AVKR_rnrm=true
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Repair Not Required Messages Enabled")
			end
		end
	end)
	
	--=================   Aardvark Not Enough Cash Message  ===================
	local AVKR_necm_cb=CreateFrame("CheckButton","Aardvark_Not Enough_Cash_Messages_Checkbox",AVKR_rop,"UICheckButtonTemplate")
	AVKR_necm_cb:ClearAllPoints()
	AVKR_necm_cb:SetParent(AVKR_e_cb)
	AVKR_necm_cb:SetPoint("BOTTOMRIGHT",AVKR_rnrm_cb,0,AVKSize.cbnxg)
	AVKR_necm_cb:SetSize(AVKSize.cbns,AVKSize.cbns)
	AVKR_necm_cb.text:SetText(" Cannot Afford Repair Messages")
	AVKR_necm_cb.text:SetFontObject(AVKCBFontN)
	-- Aardvark mark checkbox display
	-- If Aardvark Repair is disabled hide checkbox
	if Aardvark_DB.AVKR_re==true and Aardvark_DB.AVKR_necm==true then
		AVKR_necm_cb:SetChecked(true)
		AVKR_necm_cb:Show()
		elseif Aardvark_DB.AVKR_re==true and Aardvark_DB.AVKR_necm==false then
		AVKR_necm_cb:SetChecked(false)
		AVKR_necm_cb:Show()
		elseif Aardvark_DB.AVKR_re==false and Aardvark_DB.AVKR_necm==false then
		AVKR_necm_cb:SetChecked(false)
		AVKR_necm_cb:Hide()
		else
		AVKR_necm_cb:SetChecked(true)
		AVKR_necm_cb:Hide()
	end
	-- Aardvark checkbox function
	AVKR_necm_cb:SetScript("OnClick", function()
		if Aardvark_DB.AVKR_necm==true then
			Aardvark_DB.AVKR_necm=false
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Cannot Afford Repair Messages Disabled")
			end
			else
			Aardvark_DB.AVKR_necm=true
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Cannot Afford Repair Messages Enabled")
			end
		end
	end)
	
	--=================   Aardvark Vendor Cannot Repair Message   ===================
	local AVKR_mcrm_cb=CreateFrame("CheckButton","Aardvark_Merchant_Cannot_Repair_Messages_Checkbox",AVKR_rop,"UICheckButtonTemplate")
	AVKR_mcrm_cb:ClearAllPoints()
	AVKR_mcrm_cb:SetParent(AVKR_e_cb)
	AVKR_mcrm_cb:SetPoint("BOTTOMRIGHT",AVKR_necm_cb,0,AVKSize.cbnxg)
	AVKR_mcrm_cb:SetSize(AVKSize.cbns,AVKSize.cbns)
	AVKR_mcrm_cb.text:SetText(" Vendor Cannot Repair Messages")
	AVKR_mcrm_cb.text:SetFontObject(AVKCBFontN)
	-- Aardvark mark checkbox display
	-- If Aardvark Repair is disabled hide checkbox
	if Aardvark_DB.AVKR_re==true and Aardvark_DB.AVKR_vcrm==true then
		AVKR_mcrm_cb:SetChecked(true)
		AVKR_mcrm_cb:Show()
		elseif Aardvark_DB.AVKR_re==true and Aardvark_DB.AVKR_vcrm==false then
		AVKR_mcrm_cb:SetChecked(false)
		AVKR_mcrm_cb:Show()
		elseif Aardvark_DB.AVKR_re==false and Aardvark_DB.AVKR_vcrm==false then
		AVKR_mcrm_cb:SetChecked(false)
		AVKR_mcrm_cb:Hide()
		else
		AVKR_mcrm_cb:SetChecked(true)
		AVKR_mcrm_cb:Hide()
	end
	-- Aardvark checkbox function
	AVKR_mcrm_cb:SetScript("OnClick", function()
		if Aardvark_DB.AVKR_vcrm==true then
			Aardvark_DB.AVKR_vcrm=false
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Vendor Cannot Repair Messages Disabled")
			end
			else
			Aardvark_DB.AVKR_vcrm=true
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Vendor Cannot Repair Messages Enabled")
			end
		end
	end)
	
	--=================   Aardvark Repair Indicator   ===================
	local AVKR_rif_cb=CreateFrame("CheckButton","Aardvark_Repair_Meter_Checkbox",AVKR_rop,"UICheckButtonTemplate")
	AVKR_rif_cb:ClearAllPoints()
	AVKR_rif_cb:SetParent(AVKR_e_cb)
	AVKR_rif_cb:SetPoint("BOTTOMRIGHT",AVKR_mcrm_cb,0,AVKSize.cbnxg)
	AVKR_rif_cb:SetSize(AVKSize.cbns,AVKSize.cbns)
	AVKR_rif_cb.text:SetText(" Repair Meter")
	AVKR_rif_cb.text:SetFontObject(AVKCBFontN)
	-- Aardvark mark checkbox display
	-- If Aardvark Repair is disabled hide checkbox
	if Aardvark_DB.AVKR_re==true and Aardvark_DB.AVKR_rm==true then
		AVKR_rif_cb:SetChecked(true)
		AVKR_rif_cb:Hide()   --   DebugTestPrint
		elseif Aardvark_DB.AVKR_re==true and Aardvark_DB.AVKR_rm==false then
		AVKR_rif_cb:SetChecked(false)
		AVKR_rif_cb:Hide()   --   DebugTestPrint
		elseif Aardvark_DB.AVKR_re==false and Aardvark_DB.AVKR_rm==false then
		AVKR_rif_cb:SetChecked(false)
		AVKR_rif_cb:Hide()
		else
		AVKR_rif_cb:SetChecked(true)
		AVKR_rif_cb:Hide()
	end
	-- Aardvark checkbox function
	AVKR_rif_cb:SetScript("OnClick", function()
		if Aardvark_DB.AVKR_rm==true then
			Aardvark_DB.AVKR_rm=false
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Repair Meter Disabled")
			end
			else
			Aardvark_DB.AVKR_rm=true
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Repair Meter Enabled")
			end
		end
	end)
	
	--=============   Aardvark Repair Enable function   ======================
	--=========   built here to ensure the child checkboxes exist   ==========
	AVKR_e_cb:SetScript("OnClick",function()
		if Aardvark_DB.AVKR_re==true then
			AVKR_gr_cb:Hide()
			AVKR_rnrm_cb:Hide()
			AVKR_necm_cb:Hide()
			AVKR_mcrm_cb:Hide()
			AVKR_rif_cb:Hide()
			Aardvark_DB.AVKR_re=false
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Repair Disabled")
			end
			else
			Aardvark_DB.AVKR_re=true
			AVKR_gr_cb:Show()
			AVKR_rnrm_cb:Show()
			AVKR_necm_cb:Show()
			AVKR_mcrm_cb:Show()
			AVKR_rif_cb:Hide()   --   DebugTestPrint
			if Aardvark_DB.AVK_asm==true then
				print(AVKFont.fbp.."Repair Enabled")
			end
			
		end
	end)
	
	--============================================================================
	--=================    AARDVARK REPAIR FUNCTION   ======================
	--============================================================================
	
	--===================   Aardvark Repair launch frame    ==================
	local AVKR_lf=CreateFrame("Frame")
	-- Aardvark Repair Launch Frame function
	AVKR_lf:SetScript("OnEvent",function()-- Aardvark Repair Function
		-- If Aardvark Repair is enabled then repair when vendor window is opened
		if Aardvark_DB.AVKR_re==true then
			if CanMerchantRepair() then
				local repairAllCost,_=GetRepairAllCost()
				if repairAllCost~=0 then
					if CanGuildBankRepair() and Aardvark_DB.AVKR_rgr==true then
						RepairAllItems(1)
						print(AVKFont.fbpc..AVKFont.fp.."Repairs paid with guild funds :- |r"..GetCoinTextureString(repairAllCost))
						elseif GetMoney()>=repairAllCost then
						RepairAllItems()
						print(AVKFont.fbpc..AVKFont.fp.."Repairs funded by you :- |r"..GetCoinTextureString(repairAllCost))
						elseif GetMoney()<repairAllCost then
						RepairAllItems()
						if Aardvark_DB.AVKR_necm==true then
							print(AVKFont.fbpc..AVKFont.fp.."Guild won't pay and you can't afford too!")
						end
					end
					else
					if Aardvark_DB.AVKR_rnrm==true then
						print(AVKFont.fbpc..AVKFont.fp.."Repairs not required.")
					end
				end
				else
				if Aardvark_DB.AVKR_vcrm==true then
					print(AVKFont.fbpc..AVKFont.fp.."This vendor cannot repair.")
				end
			end
		end
	end)
	AVKR_lf:RegisterEvent("MERCHANT_SHOW")
	
	--============================================================================
	--=================     ABOUT AARDVARK PANEL        ==========================
	--============================================================================
	
	--=====================   Aardvark About Parent   ======================
	local AVKA_ap = CreateFrame("Frame","Aardvark_About_Parent",AVK_mFrm)
	AVKA_ap:SetSize(AVKSize.mpw,AVKSize.mph)
	AVKA_ap:SetPoint("BOTTOM",0,AVKSize.mfbs)
	AVKA_ap:SetBackdrop( {nil, insets={}, tileSize=nil, tile=false, edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16 } )
	AVKA_ap:SetBackdropBorderColor(0,1,1,1)
	AVKA_ap:Hide()
	
	--=====================   Aardvark About Text   ======================
	local AVKA_aText = CreateFrame("Frame","Aardvark_About_Text_Frame",AVKA_ap)
	AVKA_aText:SetSize(AVKSize.mpw-AVKSize.mfs,AVKSize.mph)
	AVKA_aText:SetPoint("TOPLEFT",AVKSize.mfbs,0)
	AVKA_aTxtC=AVKA_aText:CreateFontString("Aardvark_About_Text")
	--    AVKA_aTxtC:SetPoint("TOPLEFT", 10, 10)
	AVKA_aTxtC:SetJustifyH("left")
	--    AVKA_aTxtC:SetScale(.95)
	AVKA_aTxtC:SetAllPoints(AVKA_aText)
	AVKA_aTxtC:SetFontObject(TheAVKAF)
	AVKA_aTxtC:SetText(AVKText.aat)
	
	--============================================================================
	--==================   AARDVARK OPERATION FUNCTIONS  =========================
	--============================================================================
	
	function AVK_addItemToList()
		local AVK_itemType,AVK_itemID,_,_= GetCursorInfo()
		local _,AVK_itemLink,AVK_itemQuality,_,_,_,_,_,_,_,AVK_itemValue=GetItemInfo(AVK_itemID)
		if AVK_itemType~="item" then   -- if not item end
			if Aardvark_DB.AVK_almm==true then
				print(AVKFont.fbpc..AVK_itemLink.." is grey and has value. Not added to your sell list.")
			end
			elseif AVK_itemValue~=0 then  -- if is item + has value
			if AVK_itemQuality==0 then  -- if is grey end
				if Aardvark_DB.AVK_almm==true then
					print(AVKFont.fbpc..AVK_itemLink.." is grey. Not added to your sell list.")
				end
				elseif AVKS_itemOnSellList(AVK_itemID)==true then -- if already on list end
				if Aardvark_DB.AVK_almm==true then
					print(AVKFont.fbpc..AVK_itemLink.." is already in your sell list.")
				end
				else -- if not already on list add to list end
				if Aardvark_DB.AVK_almm==true then
					print(AVKFont.fbpc..AVK_itemLink..AVKFont.fg.." added to your sell list.")
				end
				table.insert(Aardvark_Sell_DB,AVK_itemID)
				AVKS_sellUpdate()
				sellButton()
			end
			elseif AVK_itemValue==0 then  -- if is item + has no value
			if AVKD_itemOnDestroyList(AVK_itemID)==true then  -- if already on destroy list end
				if Aardvark_DB.AVK_almm==true then
					print(AVKFont.fbpc..AVK_itemLink.." is already in your destroy list.")
				end
				else -- if not already on list add to list end
				if Aardvark_DB.AVK_almm==true then
					print(AVKFont.fbpc..AVK_itemLink..AVKFont.fr.." added to your destroy list.")
				end
				table.insert(Aardvark_Destroy_DB,AVK_itemID)
				AVKD_destroyUpdate()
				destroyButton()
			end
			else
			print("What the hell just happened?")   --   DebugTestPrint
		end
		ClearCursor()
	end
	
	function updateMerchButtons()
		-- If AVK vendor button enabled show on merchant frame
		if Aardvark_DB.AVK_avb==true then
			AVK_aMercBtn:Show()
			else
			AVK_aMercBtn:Hide()
		end
		-- If Sell enabled + sell vendor button enabled show on merchant frame - else hide
		if Aardvark_DB.AVKS_se==true then
			if Aardvark_DB.AVKS_svb==true then
				AVKS_sVenBtn:Show()
				else
				AVKS_sVenBtn:Hide()
			end
			else
			AVKS_sVenBtn:Hide()
		end
		-- If Destroy enabled + destroy vendor button enabled show on merchant frame - else hide
		if Aardvark_DB.AVKD_de==true then
			if Aardvark_DB.AVKD_dvb==true then
				AVKD_dVenBtn:Show()
				else
				AVKD_dVenBtn:Hide()
			end
			else
			AVKD_dVenBtn:Hide()
		end
	end
	
	-- Aardvark Sell DB Clean function
	function cleanAVKS_DB()
		Aardvark_Sell_DB={}
		AVKS_sellUpdate()
	end
	
	-- Aardvark Destroy DB Clean function
	function cleanAVKD_DB()
		Aardvark_Destroy_DB={}
		AVKD_destroyUpdate()
	end
	
	-- Aardvark Reset Layout function
	function resetPos()
		AVK_mFrm:ClearAllPoints()
		AVK_mFrm:SetPoint("LEFT",300,50)
		AVK_mFrm:Show()
		AVK_mainBtn:ClearAllPoints()
		AVK_mainBtn:SetPoint("LEFT",380,300)
		AVK_mainBtn:Show()
	end
	
	-- Aardvark Side Button Option function
	function optionsButton()
		AVKS_sp:Hide()
		AVKS_sop:Hide()
		AVKD_dp:Hide()
		AVKD_dop:Hide()
		AVKA_ap:Hide()
		AVKR_rop:Hide()
		AVK_op:Show()
	end
	
	-- Aardvark Side Button Sell function
	function sellButton()
		AVKS_sellUpdate()
		AVK_op:Hide()
		AVKS_sop:Hide()
		AVKD_dp:Hide()
		AVKD_dop:Hide()
		AVKA_ap:Hide()
		AVKR_rop:Hide()
		AVKS_sp:Show()
	end
	
	-- Aardvark Sell Options Button function
	function sellOptionsButton()
		AVK_op:Hide()
		AVKS_sp:Hide()
		AVKD_dp:Hide()
		AVKD_dop:Hide()
		AVKA_ap:Hide()
		AVKR_rop:Hide()
		AVKS_sop:Show()
	end
	
	-- Aardvark Side Button Destroy function
	function destroyButton()
		AVKD_destroyUpdate()
		AVK_op:Hide()
		AVKS_sp:Hide()
		AVKS_sop:Hide()
		AVKD_dop:Hide()
		AVKA_ap:Hide()
		AVKR_rop:Hide()
		AVKD_dp:Show()
	end
	
	-- Aardvark Destroy Options Button function
	function destroyOptionsButton()
		AVK_op:Hide()
		AVKS_sp:Hide()
		AVKD_dp:Hide()
		AVKA_ap:Hide()
		AVKR_rop:Hide()
		AVKS_sop:Hide()
		AVKD_dop:Show()
	end
	
	-- Aardvark Side Button Repair function
	function repairButton()
		AVK_op:Hide()
		AVKS_sp:Hide()
		AVKS_sop:Hide()
		AVKD_dp:Hide()
		AVKD_dop:Hide()
		AVKA_ap:Hide()
		AVKR_rop:Show()
	end
	
	-- Aardvark Side Button Aardvark function
	function aardvarkButton()
		AVK_op:Hide()
		AVKS_sp:Hide()
		AVKS_sop:Hide()
		AVKD_dp:Hide()
		AVKD_dop:Hide()
		AVKR_rop:Hide()
		AVKA_ap:Show()
	end
	
	--============================================================================
	--======================    SLASH COMMANDS    ================================
	--============================================================================
	
	-- Slash Command Show Frame
	SLASH_AARDVARK1="/avk"
	function SlashCmdList.AARDVARK(msg,editbox)
		AVKS_sellUpdate()
		AVKD_destroyUpdate()
		AVK_mFrm:Show()
	end
	
	-- Slash Command Reset Frame and Button Position
	SLASH_AARDVARKRFP1="/avkpos"
	function SlashCmdList.AARDVARKRFP(msg,editbox)
		resetPos()
	end
	
	-- Slash Command Destroy
	SLASH_AARDVARKD1="/avkdestroy"
	function SlashCmdList.AARDVARKD(msg,editbox)
		AVKD_destroy()
	end
	
	-- Slash Command Clean All Lists
	SLASH_AARDVARKCB1="/avkclean"
	function SlashCmdList.AARDVARKCB(msg,editbox)
		cleanAVKS_DB()
		cleanAVKD_DB()
		optionsButton()
		if Aardvark_DB.AVK_asm==true then
			print(AVKFont.fbp.."Sell & Destroy Lists Cleared")
		end
	end
	
	-- Slash Command Reset All
	SLASH_AARDVARKRA1="/avkreset"
	function SlashCmdList.AARDVARKRA(msg,editbox)
		Aardvark_DB=nil
		ReloadUI()
		AVK_mainBtn:Hide()
		AVK_mFrm:Hide()
		resetPos()
	end
end)
AVK_mFrm:RegisterEvent("PLAYER_LOGIN")

--============================================================================
--=================           AARDVARK BUTTONS           =====================
--============================================================================

--=====================   Aardvark Main Button    ======================
AVK_mainBtn=CreateFrame("Button","AVK_Main_Button",UIParent)
AVK_mainBtn:SetSize(35,35)
AVK_mainBtn:ClearAllPoints()
AVK_mainBtn:SetPoint("LEFT",380,300)
AVK_mainBtn:SetNormalTexture(AVKImg.avki)
AVK_mainBtn:SetHighlightTexture(AVKImg.avki_alt,"BLEND")

AVK_mainBtn:SetMovable(true)
AVK_mainBtn:SetClampedToScreen(true)
AVK_mainBtn:RegisterForDrag("MiddleButton")
AVK_mainBtn:SetScript("OnDragStart",AVK_mainBtn.StartMoving)
AVK_mainBtn:SetScript("OnDragStop",AVK_mainBtn.StopMovingOrSizing)

AVK_mainBtn:SetScript("OnEnter",function(self)
    GameTooltip:SetOwner(self,"ANCHOR_TOP")
    GameTooltip:SetText(AVKFont.fb..AVKTitle)
    GameTooltip:AddLine(AVKText.att)
    GameTooltip:SetScale(.90)
    GameTooltip:Show()
end)

AVK_mainBtn:SetScript("OnLeave",function(self)
    GameTooltip:Hide()
    GameTooltip:SetScale(1)
end)

AVK_mainBtn:SetScript("OnReceiveDrag",function()
    if GetCursorInfo() then
		AVK_addItemToList()
	end
end)

AVK_mainBtn:RegisterForClicks("RightButtonUp", "LeftButtonUp")
AVK_mainBtn:SetScript("OnClick", function(self, button)
    if button=="RightButton" then
		AVKD_destroy()
		elseif button=="LeftButton" then
		if GetCursorInfo() then
			AVK_addItemToList()
			else
			if AVK_mFrm:IsShown()==false then
				AVKS_sellUpdate()
				AVKD_destroyUpdate()
				AVK_mFrm:Show()
				else
				AVK_mFrm:Hide()
			end
		end
	end
end)
